"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const debug_1 = __importDefault(require("debug"));
const express_1 = __importStar(require("express"));
const http_1 = require("http");
const path_1 = require("path");
const socket_io_1 = __importDefault(require("socket.io"));
const utils_1 = require("./utils");
const logger = debug_1.default("testing-library-spy:subprocess");
const CLIENT_ASSETS_PATH = path_1.join(__dirname, "../../../client/dist");
process.on("unhandledRejection", (error) => {
    throw error;
});
async function startServer() {
    logger("Starting server...");
    const app = express_1.default();
    app.use("/", express_1.static(CLIENT_ASSETS_PATH, { maxAge: "1y" }));
    const server = http_1.createServer(app);
    const port = utils_1.getPort();
    await new Promise((resolve) => {
        server.listen(port, resolve);
    });
    logger(`Server started at port ${port}`);
    const io = socket_io_1.default(server);
    return { io, server };
}
async function run() {
    const { io } = await startServer();
    let lastMessage;
    io.on("connection", (socket) => {
        if (lastMessage === undefined) {
            logger("New client connected, but no new message to send.");
        }
        else {
            logger("New client connected, sending last message %s", lastMessage);
            socket.emit("spy:message", lastMessage);
        }
    });
    process.on("message", (message) => {
        logger("Got message %o", message);
        io.volatile.emit("spy:message", message);
        lastMessage = message;
    });
}
run();
