declare global {
    const afterAll: undefined | ((callback: () => void) => void);
    const teardown: undefined | ((callback: () => void) => void);
}
/**
 * Initialize Spy console.
 *
 * Will also hook into testing library, JSDOM, and if running inside tests, register its own cleanup at the end of the run.
 */
export declare const initSpyConsole: () => void;
/**
 * Destroy Spy console.
 *
 * There is no need to call this manually, if your test runner supports either `afterAll()` or `teardown()` methods.
 */
export declare const destroySpyConsole: () => void;
